/*
 *  This file is automatically generated and does not require a license
 *
 *  ==== WARNING: CHANGES TO THIS GENERATED FILE WILL BE OVERWRITTEN ====
 *
 *  To make changes to the generated code, use the space between existing
 *      "USER CODE START (section: <name>)"
 *  and
 *      "USER CODE END (section: <name>)"
 *  comments, where <name> is a single word identifying the section.
 *  Only these sections will be preserved.
 *
 *  Do not move these sections within this file or change the START and
 *  END comments in any way.
 *  ==== ALL OTHER CHANGES WILL BE OVERWRITTEN WHEN IT IS REGENERATED ====
 *
 *  This file was generated from
 *      D:/TI/grace_2_20_01_12/packages/ti/mcu/msp430/csl/interrupt_vectors/InterruptVectors_init.xdt
 */
#include <msp430.h>

/* USER CODE START (section: InterruptVectors_init_c_prologue) */
/* User defined includes, defines, global variables and functions */
#include "../../user_define.h"
/* USER CODE END (section: InterruptVectors_init_c_prologue) */

/*
 *  ======== InterruptVectors_graceInit ========
 */
void InterruptVectors_graceInit(void)
{
}


/* Interrupt Function Prototypes */


/*
 *  ======== USCI A0/B0 TX Interrupt Handler Generation ========
 *
 * Here are several important notes on using USCI_A0/B0 TX interrupt Handler:
 * 1. User could use the following code as a template to service the interrupt
 *    handler. Just simply copy and paste it into your user definable code
 *    section.
 *  For UART and SPI configuration:

    if (IFG2 & UCA0TXIFG) {

    }
    else if (IFG2 & UCB0TXIFG) {

    }

 *  For I2C configuration:
    if (IFG2 & UCA0/B0TXIFG) {

    }
    else if (IFG2 & UCA0/B0RXIFG) {

    }


 * 2. User could also exit from low power mode and continue with main
 *    program execution by using the following instruction before exiting
 *    this interrupt handler.
 *
 *    __bic_SR_register_on_exit(LPMx_bits);
 */
#pragma vector=USCIAB0TX_VECTOR
__interrupt void USCI0TX_ISR_HOOK(void)
{
    /* USER CODE START (section: USCI0TX_ISR_HOOK) */
    /* replace this comment with your code */
	if (UCB0TXIFG & IFG2){		// Transmitter interrupt ?
	    if (I2C_TxByteCnt) {            // Check TX byte counter
	        UCB0TXBUF = *I2C_TxDataPtr++; // Load TX buffer
	        I2C_TxByteCnt--;            // Decrement TX byte counter
	    }
	    else {
	        UCB0CTL1 |= UCTXSTP;     // I2C stop condition
	        IFG2 &= ~UCB0TXIFG;      // Clear USCI_B0 TX int flag
	        __bic_SR_register_on_exit(LPM0_bits);   // Exit LPM if all data was transmitted
	    }
	}
	else
	if (UCB0RXIFG & IFG2){		// I2C master receive data interrupt
		I2C_RxByteCnt--;                                 // Decrement RX byte counter
		if (I2C_RxByteCnt) {
			*I2C_RxDataPtr++ = UCB0RXBUF;                  // Move RX data to address PRxData
		    if (I2C_RxByteCnt == 1){
		    	UCB0CTL1 |= UCTXSTP; // Only one byte left? Generate I2C stop condition
		    }
		}
		else {
			*I2C_RxDataPtr = UCB0RXBUF;   // Move final RX data to PRxData
			//__bic_SR_register_on_exit(LPM0_bits); // Exit LPM if all expected data was Rxed
		}
	}
	else {
		;			// any other cause
	}
    /* USER CODE END (section: USCI0TX_ISR_HOOK) */
}

/*
 *  ======== USCI A0/B0 RX Interrupt Handler Generation ========
 *
 * Here are several important notes on using USCI_A0/B0 RX interrupt Handler:
 * 1. User could use the following code as a template to service the interrupt
 *    handler. Just simply copy and paste it into your user definable code
 *    section.
 *  For UART and SPI configuration:

    if (IFG2 & UCA0RXIFG) {

    }
    else if (IFG2 & UCB0RXIFG) {

    }

*  For I2C configuration:
    if (UCB0STAT & UCSTTIFG) {

    }
    else if (UCB0STAT & UCSTPIFG) {

    }
    else if (UCB0STAT & UCNACKIFG) {

    }
    else if (UCB0STAT & UCALIFG) {

    }

 * 2. User could also exit from low power mode and continue with main
 *    program execution by using the following instruction before exiting
 *    this interrupt handler.
 *
 *    __bic_SR_register_on_exit(LPMx_bits);
 */
#pragma vector=USCIAB0RX_VECTOR
__interrupt void USCI0RX_ISR_HOOK(void)
{
    /* USER CODE START (section: USCI0RX_ISR_HOOK) */
    /* replace this comment with your code */
	unsigned char rx_byte;
	rx_byte = UCA0RXBUF;      // read receive byte
	if (UART_RCV_LEN < UART_RXBUFMAX){
	    UART_RXDBUF[UART_RCV_PTR] = rx_byte;
	    UART_RCV_LEN++;
	    if (UART_RCV_PTR < (UART_RXBUFMAX-1)){
	      UART_RCV_PTR++;
	    } else {
	      UART_RCV_PTR = 0;    // ptr increment s cyclic
	    }
	  } else {    // receive buffer full, ignore rxd
	  }
    /* USER CODE END (section: USCI0RX_ISR_HOOK) */
}
