/*
	user_define.h
*/


#ifndef _USER_DEFS_
#define _USER_DEFS_


/* ======== general definition ======== */
#define	BOOL	unsigned char
#define TRUE	1
#define FALSE	0

/* ================================================
 * uart.c  related defines,vars,functions
 * ================================================ */
/* -------- define for serial port (UART) -------- */
#define BEL   0x07
#define BS    0x08
#define SPC   0x20
#define CR    0x0d
#define LF    0x0a

#define UART_RXBUFMAX  40

/* -------- global var. for serial port -------- */
extern unsigned char UART_RXDBUF[UART_RXBUFMAX];
extern int UART_RCV_PTR, UART_READ_PTR, UART_RCV_LEN;

/* -------- functions for serial port -------- */
int uart_sendchar(unsigned char data);
void uart_sendstr(char *s);
unsigned char uart_getchar();
unsigned int recv_len();


/* ================================================
 * i2c.c  related defines,vars,functions
 * ================================================ */
/* -------- define for i2c -------- */
#define I2C_BUFSIZE	64
#define E_OK		0
#define E_NACK		(-1)
#define E_TMOUT		(-2)
#define E_NOTFND	(-3)
#define E_BUSY		(-4)

/* -------- global var. for i2c -------- */
extern unsigned char I2C_SLAVE_ADR;
extern unsigned char I2C_BUF_W[I2C_BUFSIZE];
extern unsigned char I2C_BUF_R[I2C_BUFSIZE];
extern int I2C_TxByteCnt, I2C_RxByteCnt;
extern unsigned char *I2C_TxDataPtr, *I2C_RxDataPtr;

/* -------- functions for i2c -------- */
int i2c_send(unsigned int slave_addr, unsigned char *txdata, int txlen);
int i2c_recv(unsigned int slave_addr, unsigned char *rxdata, int rxlen);
void i2c_stop(void);
void i2c_reset(void);

/* ================================================
 * uart_session.c  related defines,vars,functions
 * ================================================ */

/* -------- define for uart_sesstion -------- */
#define CMDLINE_BUFSIZE 80

/* -------- global var. for uart_sesstion -------- */
extern unsigned char CMDLINE[CMDLINE_BUFSIZE];
extern void session(void);
void show_version(void);

/* -------- functions for uart_sesstion -------- */


/* ================================================
 * grace generated functions
 * ================================================ */
void USCI_B0_graceInit(void);
void System_graceInit(void);

#endif  /* _USER_DEFS_ */

